HDU--1298 -- T9 [字典树+深搜]


T9


Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1273 Accepted Submission(s): 506

Problem Description
A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be entered by pressing one key several times. For example, if you wanted to type "hello" you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people from using the Short Message Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The "9" in the name means that you can enter almost arbitrary words with just nine keys and without pressing them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the "most probable" word matching the input. For example, to enter "hello" you simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word "gdjjm", but since this is no sensible English word, it can safely be ignored. By ruling out all other "improbable" solutions and only taking proper English words into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.


Figure 8: The Number-keys of a mobile phone.


More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words "idea" and "hello", with "idea" occurring more often. Pressing the keys 4, 3, 5, 5, and 6, one after the other, the phone offers you "i", "id", then switches to "hel", "hell", and finally shows "hello".

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with this character combination. For example, if the dictionary contains three words "hell", "hello", and "hellfire", the probability of the character combination "hell" is the sum of the probabilities of these words. If some combinations have the same probability, your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word "hello" is in the dictionary, the user can also enter the word "he" by pressing the keys 4 and 3 even if this word is not listed in the dictionary.

Input
The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it's a dictionary.) Every line starts with the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning "next word".

Output
The output for each scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above. Whenever none of the words in the dictionary match the given number sequence, print "MANUALLY" instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.

Sample Input
  
  
2 5 hell 3 hello 4 idea 8 next 8 super 3 2 435561 43321 7 another 5 contest 6 follow 3 give 13 integer 6 new 14 program 4 5 77647261 6391 4681 26684371 77771
Sample Output
  
  
Scenario #1: i id hel hell hello i id ide idea Scenario #2: p pr pro prog progr progra program n ne new g in int c co con cont anoth anothe another p pr MANUALLY MANUALLY


Code:


本题本种解法基本思路为:

在每个节点存放的不是单个字母或者不存,而是这个字母前的所有字母,即一个字符串,

搜索到尽头的时候也只需将这个字符串输出即可

缺点是每一次搜索都是从输入的第一个数字开始,到第一个输出一个字符串,再从第一个数字开始到第二个数字输出一个字符串,,以此类推,这样稍微有些浪费时间

所以比较好的就是在结点存放一个字母,用栈来保存每一次的结果,发现结点不满足条件就出栈,这样保留的一直就是符合条件的了


#include"stdio.h"
#include"stdlib.h"
#include"string.h" 
#include"stack"
#include"iostream"
using namespace std;

typedef struct node
{
	int val;
	node *next[26];
	char word[105];//把之前的一段字母都存起来 
}node;

node memory[100010];//数组分配空间,节约时间 
int cnt=0,Max;
node *tree;//头结点
char map[10][5],in[105],res[105]; 

void set()  //定义map[][]
{
    strcpy(map[0],"");
    strcpy(map[1],"");
    strcpy(map[2],"abc");
    strcpy(map[3],"def");
    strcpy(map[4],"ghi");
    strcpy(map[5], "jkl");
    strcpy(map[6],"mno");
    strcpy(map[7],"pqrs");
    strcpy(map[8],"tuv");
    strcpy(map[9],"wxyz");
}

node* create()
{
	node *p;
	int i;
	p = &memory[cnt++];
	p->val = 0;
	for(i=0;i<26;i++)
		p->next[i] = NULL;
	return p;
}

void insert(char c[],int val)
{
	node *p;
	char str[105];
	p = tree;
	int i,j;
	for(i=0;i<strlen(c);i++)
	{
		j = c[i]-'a';
		if(p->next[j]==NULL)
		{
			p->next[j] = create();	
		}			
		p = p->next[j];
		p->val += val;
		str[i] = c[i];
		str[i+1] = 0;
		strcpy(p->word,str);//该点保存之前的所有字母,即一个字符串,便于输出 	
	}
} 

void dfs(node *p,int cur,int end)//cur:当前位置,第几个数字,end:目标位置 
{	
	if(cur == end)
	{
	
		 if(p->val>Max)//找到一个最大的优先级
		 {
		 	strcpy(res,p->word);//输出这个字符串
			Max = p->val; 
		 } 
		 return;
	}
	int k,n,i,j;
	k = in[cur+1] - '0';//从下个数字开始,-'0'是把字符型的数字转换成数字 
//	printf("k:%d\n",k);
	n = strlen(map[k]);//表示这个按键上有几个字母,三个或者四个~ 
	//printf("n:%d\n",n);
	//puts(map[k]);
	for(i=0;i<n;i++)
	{
		j = map[k][i] - 'a';//从这几个字母第一个开始.如果有就继续深搜,没有就看下个字母 
		if(p->next[j]==NULL) continue;
		else dfs(p->next[j],cur+1,end); 
	}		
}

int main()
{
	int t,cas,n,val,i;
	char str[105];
	scanf("%d",&t);
	for(cas=1;cas<=t;cas++)
	{
		memset(memory,0,sizeof(memory));
		cnt = 0;
		tree = create();
		scanf("%d",&n);
		for(i=0;i<n;i++)//输入单词创建字典树 
		{
			scanf("%s%d",str,&val);
			insert(str,val);
		}
		printf("Scenario #%d:\n",cas);
		scanf("%d",&n);
		set();
		while(n--)
		{
			scanf("%s",in);	
			for(i=0;in[i]!='1';i++)//输入了几个数字就有-1次循环,每个数字都是目标位置 
			{
				Max = -1;
				dfs(tree,-1,i);//-1是第-1个数 
				if(Max!=-1) printf("%s\n",res);
				else printf("MANUALLY\n");
			}
			if(n!=0) printf("\n");	 
		}
		printf("\n\n");		
	}
	return 0; 
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值